---
title: mask-border
slug: Web/CSS/mask-border
tags:
  - CSS
  - CSS Masking
  - CSS Property
  - Experimental
  - NeedsCompatTable
  - Reference
  - 'recipe:css-shorthand-property'
---
<div>{{cssref}}{{SeeCompatTable}}</div>

<p>The <strong><code>mask-border</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Shorthand_properties">shorthand property</a> lets you create a mask along the edge of an element's border.</p>

<h2 id="Constituent_properties">Constituent properties</h2>

<p>This property is a shorthand for the following CSS properties:</p>

<ul>
 <li><a href="/en-US/docs/Web/CSS/mask-border-mode"><code>mask-border-mode</code></a></li>
 <li><a href="/en-US/docs/Web/CSS/mask-border-outset"><code>mask-border-outset</code></a></li>
 <li><a href="/en-US/docs/Web/CSS/mask-border-repeat"><code>mask-border-repeat</code></a></li>
 <li><a href="/en-US/docs/Web/CSS/mask-border-slice"><code>mask-border-slice</code></a></li>
 <li><a href="/en-US/docs/Web/CSS/mask-border-source"><code>mask-border-source</code></a></li>
 <li><a href="/en-US/docs/Web/CSS/mask-border-width"><code>mask-border-width</code></a></li>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: css no-line-numbers notranslate">/* source | slice */
mask-border: url('border-mask.png') 25;

/* source | slice | repeat */
mask-border: url('border-mask.png') 25 space;

/* source | slice | width */
mask-border: url('border-mask.png') 25 / 35px;

/* source | slice | width | outset | repeat | mode */
mask-border: url('border-mask.png') 25 / 35px / 12px space alpha;
</pre>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>&lt;'mask-border-source'&gt;</code></dt>
 <dd>The source image. See {{cssxref("mask-border-source")}}.</dd>
 <dt><code>&lt;'mask-border-slice'&gt;</code></dt>
 <dd>The dimensions for slicing the source image into regions. Up to four values may be specified. See {{cssxref("mask-border-slice")}}.</dd>
 <dt><code>&lt;'mask-border-width'&gt;</code></dt>
 <dd>The width of the border mask. Up to four values may be specified. See {{cssxref("mask-border-width")}}.</dd>
 <dt><code>&lt;'mask-border-outset'&gt;</code></dt>
 <dd>The distance of the border mask from the element's outside edge. Up to four values may be specified. See {{cssxref("mask-border-outset")}}.</dd>
 <dt><code>&lt;'mask-border-repeat'&gt;</code></dt>
 <dd>Defines how the edge regions of the source image are adjusted to fit the dimensions of the border mask. Up to two values may be specified. See {{cssxref("mask-border-repeat")}}.</dd>
 <dt><code>&lt;'mask-border-mode'&gt;</code></dt>
 <dd>Defines whether the source image is treated as a luminance mask or alpha mask. See {{cssxref("mask-border-mode")}}.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Setting_a_bitmap-based_mask_border">Setting a bitmap-based mask border</h3>

<p>In this example, we will mask an element's border with a diamond pattern. The source for the mask is a ".png" file of 90 by 90 pixels, with three diamonds going vertically and horizontally:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/15836/mask-border-diamonds.png" style="height: 90px; width: 90px;"></p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;div id="bitmap"&gt;This element is surrounded by a bitmap-based mask border! Pretty neat, isn't it?&lt;/div&gt;</pre>

<h4 id="CSS">CSS</h4>

<p>To match the size of a single diamond, we will use a value of 90 divided by 3, or <code>30</code>, for slicing the image into corner and edge regions. A repeat value of <code>round</code> will make the mask slices fit evenly, i.e., without clipping or gaps.</p>

<pre class="brush: css notranslate">div {
  width: 200px;
  background-color: lavender;
  border: 18px solid salmon;
  padding: 10px;

  /* Prefixed longhand properties currently supported in Chromium
    -webkit-mask-box-image-source: url(https://mdn.mozillademos.org/files/15836/mask-border-diamonds.png);
    -webkit-mask-box-image-slice: 30 fill;
    -webkit-mask-box-image-width: 20px;
    -webkit-mask-box-image-repeat: round;
    -webkit-mask-box-image-outset: 1px;
  */

  /* Prefixed shorthand property currently supported in Chromium */
  -webkit-mask-box-image: url("https://mdn.mozillademos.org/files/15836/mask-border-diamonds.png") /* source */
  30 fill /          /* slice */
  20px /             /* width */
  1px                /* outset */
  round;             /* repeat */

  /* Updated standard shorthand property, not supported anywhere yet */
  mask-border:
    url("https://mdn.mozillademos.org/files/15836/mask-border-diamonds.png")  /* source */
    30 fill /        /* slice */
    20px /           /* width */
    1px              /* outset */
    round;           /* repeat */
}
</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Setting_a_bitmap-based_mask_border")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS Masks", "#propdef-mask-border", "mask-border")}}</td>
   <td>{{Spec2("CSS Masks")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.mask-border")}}</p>

<h2 id="See_also">See also</h2>

<ul>
  <li>{{cssxref("mask-border-mode")}}</li>
  <li>{{cssxref("mask-border-outset")}}</li>
  <li>{{cssxref("mask-border-repeat")}}</li>
  <li>{{cssxref("mask-border-source")}}</li>
  <li>{{cssxref("mask-border-width")}}</li>
</ul>
